         PRINT NOGEN
         BEGIN NAME=QKP050,IBM=YES,TPFISOC=YES
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
         MACRO
         INPARMS
INPARMS  DSECT
KPT      DS    C
KSAREQ   DS    X
KBAREQ   DS    X
KLGFBAREQ DS   X
HDRSREQ  DS    X
REFRESH  DS    X
DOERRS   DS    XL2
TOUT     DS    X
CSO      DS    X
BSO      DS    X
PROCREQ  DS    X
CPUORD   DS    XL2
CPUID    DS    C
IMAGE    DS    X
SNAP     DS    X
VERBOSE  DS    X
TAG      DS    X
EVTNAME  DS    XL8
&SYSECT  CSECT
         MEND
*        EQUATES               *
HOLDA    EQU   1
HOLDB    EQU   2
HOLDC    EQU   3
HOLDD    EQU   4
HOLDE    EQU   5
HOLDI    EQU   6
HOLDM    EQU   7
HOLDV    EQU   8
HOLD0    EQU   9
HOLD1    EQU   10
HOLD2    EQU   11
HOLD3    EQU   12
HOLD4    EQU   13
HOLD5    EQU   14
HOLD6    EQU   15
HOLD9    EQU   16
HOLDZ    EQU   17
***********************************************************************
* Interface to QKP3                                                   *
***********************************************************************
QKP3_TAG_DATA     EQU   EBW000,4        TAG DATA MOVED TO LAST-FILED-BY
QKP3_KPT_PARM     EQU   EBW004          KEYPOINT TO BE TAGGED
QKP3_KPT_PARMA    EQU   EBW005          BLANK FOR WTOPC DISPLAY OF KPT
QKP3_TARGET_PROC  EQU   EBW006          CHAR PROCESSOR
QKP3_PROC_ORD     EQU   EBW007,2        PROCESSOR ORDINAL
*
QKP3_LOCATION     EQU   EBW009          TARGET AREA
QKP3_KSA          EQU   B'10000000'     KSA INDICATOR
QKP3_KBA          EQU   B'01000000'     KBA INDICATOR
QKP3_KLGFBA       EQU   B'00100000'     KLGFBA INDICATOR
QKP3_IMAGE_NO     EQU   EBW010          TARGET IMAGE NUMBER
QKP3_VERBOSE      EQU   EBW011          VERBOSE INDICATOR
*
QKP3_FACETYPE     EQU   EBW012,8        SYMBOLIC FACE TYPE
QKP3_ORDINAL      EQU   EBW020,8        KEYPOINT ORDINAL
QKP3_FADDR        EQU   EBW028,8        KEYPOINT FILE ADDRESS
QKP3_RETCODE      EQU   EBW036          RETURN CODE TO CALLER
QKP3_RET_OK       EQU   0               GOOD RETURN
QKP3_RET_FAIL     EQU   1               REQUEST FAILED
QKP3_RET_INVALID  EQU   2               REQUEST INVALID
*
QKP3_SIPDATA_LEN  EQU   37              LENGTH OF ABOVE DATA
**********************************************************************
         MACRO
         KPTTEST &KEYPOINT=,&PARMS=
         LCLC    &KPT,&INPARMS
&KPT     SETC    '&KEYPOINT'
&INPARMS SETC    '&PARMS'
         PRINT GEN
***********************************************************************
* This macro is a skeleton keypoint test.                             *
*  &KPT = the keypoint to be tested.                                  *
*  &INPARMS is an 8-byte core address of the parameter list           *
***********************************************************************
         USING INPARMS,R5
         LG    R5,&INPARMS      PASSED FROM QKP000
         J     KPT&KPT
GETKP_TAG&KPT  DC    C'KPTS'
SNAPKPT&KPT DS    0H
         CLI   SNAP,X'01'
         JNE   SNAPRET_KP&KPT
         STG   R1,EBX016
         SNAPC R,FFFFF,LIST=LISTKPT&KPT
         J     SNAPRET_KP&KPT
LISTKPT&KPT LISTC NAME=KPT&KPT,TAG=EBX016,LEN=20,INDIR=YES,INDSIZE=64
         LISTC END
SNAPRET_KP&KPT    DS  0H
         BR    R6
*
**********************************************************************
* KPT ERROR TEST CASES                                               *
**********************************************************************
GETKP_DOERRS&KPT DS 0H
         XGR   R1,R1
         ICM   R1,B'0011',DOERRS
         BCTR  R1,0
         SLL   R1,2
         B      *+4(R1)
         J      ETEST_CASE1&KPT
         J      ETEST_CASE2&KPT
         J      ETEST_CASE3&KPT
         J      ETEST_CASE4&KPT
         J      ETEST_CASE5&KPT
         J      ETEST_CASE6&KPT
         J      ETEST_CASE7&KPT
         J      ETEST_CASE8&KPT
         J      ETEST_CASE9&KPT
         SPACE
KPT&KPT     DS    0H
         MVI   KPT,C'&KPT'
         OC    DOERRS,DOERRS
         JNZ   GETKP_DOERRS&KPT
*
         LGHI  R2,1               MSG 1
         BRASL  R6,KP_WTOPC_I

*   TAG KEYPOINT
         CLI   TAG,X'01'          DO WE TAG?
         JNE   TAGKPT_1_NO&KPT
         MVI   QKP3_LOCATION,X'00'
         MVC   QKP3_TAG_DATA,GETKP_TAG&KPT
         MVC   QKP3_KPT_PARM,KPT
         MVI   QKP3_TARGET_PROC,X'00'
         MVC   QKP3_VERBOSE,VERBOSE
         MVC   QKP3_PROC_ORD,CPUORD
         MVC   QKP3_IMAGE_NO,X'00'
         ENTRC QKP3
         CLI   QKP3_RETCODE,QKP3_RET_OK
         JNE   GETKP_ERROR9&KPT
TAGKPT_1_NO&KPT   DS 0H
         GETKC KPT=&KPT,DATA=R1,ERROR=GETKP_ERROR1&KPT
         CLI   TAG,X'01'          DO WE TAG?
         JNE   TAGKPT_2_NO&KPT
         CLC   4(4,R1),QKP3_TAG_DATA
         JNE   GETKP_ERROR9&KPT
TAGKPT_2_NO&KPT   DS 0H
         JAS   R6,SNAPKPT&KPT
         LGHI  R2,2               MSG 2
         BRASL R6,KP_WTOPC_I
         FREEC BLOCK=R1
*
         LGHI  R2,3               MSG 3
         BRASL R6,KP_WTOPC_I
         GETKC KPT=&KPT,DATA=R1,HOLD,ERROR=GETKP_ERROR2&KPT
         CLI   TAG,X'01'          DO WE TAG?
         JNE   TAGKPT_3_NO&KPT
         CLC   4(4,R1),QKP3_TAG_DATA
         JNE   GETKP_ERROR9_UNHOLD&KPT
TAGKPT_3_NO&KPT   DS 0H
         LGHI  R2,4               MSG 4
         BRASL R6,KP_WTOPC_I
         JAS   R6,SNAPKPT&KPT
         LGHI  R2,5               MSG 5
         BRASL R6,KP_WTOPC_I
         UPDKC KPT=&KPT,DATA=R1,NOWAIT,ERROR=GETKP_ERROR8&KPT
         WAITC GETKP_ERROR8&KPT
         UPDKC KPT=&KPT,DATA=R1,ERROR=GETKP_ERROR8&KPT
         LGHI  R2,6               MSG 6
         BRASL R6,KP_WTOPC_I
         LGHI  R2,10              MSG 10
         BRASL R6,KP_WTOPC_I
         RELKC KPT=&KPT
         LGHI  R2,7               MSG 7
         BRASL R6,KP_WTOPC_I
*
         FREEC BLOCK=R1
         GETKC KPT=&KPT,DATA=R1,ERROR=GETKP_ERROR1&KPT
         CLI   TAG,X'01'          DO WE TAG?
         JNE   TAGKPT_4_NO&KPT
         CLC   4(4,R1),QKP3_TAG_DATA
         JE    GETKP_ERROR9&KPT      DID NOT GET FILED IF EQUAL
TAGKPT_4_NO&KPT   DS 0H
         FREEC BLOCK=R1

         LGHI  R2,8               MSG 8
         BRASL R6,KP_WTOPC_I

*   TAG KEYPOINT
         CLI   TAG,X'01'          DO WE TAG?
         JNE   TAGKPT_5_NO&KPT
         MVI   QKP3_LOCATION,X'00'
         MVC   QKP3_TAG_DATA,GETKP_TAG&KPT
         MVC   QKP3_KPT_PARM,KPT
         MVC   QKP3_TARGET_PROC,X'00'
         MVC   QKP3_VERBOSE,VERBOSE
         MVC   QKP3_PROC_ORD,CPUORD
         MVC   QKP3_IMAGE_NO,X'00'
         ENTRC QKP3
         CLI   QKP3_RETCODE,QKP3_RET_OK
         JNE   GETKP_ERROR9&KPT
TAGKPT_5_NO&KPT   DS 0H
         GETKC KPT=&KPT,DATA=R1,HOLD,ERROR=GETKP_ERROR2&KPT
         CLI   TAG,X'01'          DO WE TAG?
         JNE   TAGKPT_6_NO&KPT
         CLC   4(4,R1),QKP3_TAG_DATA
         JNE   GETKP_ERROR9_UNHOLD&KPT
TAGKPT_6_NO&KPT   DS 0H
         LGHI  R2,9               MSG 9
         BRASL R6,KP_WTOPC_I
         BRAS  R6,SNAPKPT&KPT
         LGHI  R2,11              MSG 11
         BRASL R6,KP_WTOPC_I
         UPDKC KPT=&KPT,DATA=R1,UNHOLD,ERROR=GETKP_ERROR8&KPT
         LGHI  R2,12              MSG 12
         BRASL R6,KP_WTOPC_I
*
         FREEC BLOCK=R1
*
         CLI   HDRSREQ,X'01'
         JNE   GETKP_NOHDRS_TEST&KPT
         LGHI  R2,13              MSG 13
         BRASL R6,KP_WTOPC_I
         GETKC KPT=&KPT,DATA=R1,ERROR=GETKP_ERROR7&KPT,HDRS
         BRAS  R6,SNAPKPT&KPT
         LGHI  R2,14              MSG 14
         BRASL R6,KP_WTOPC_I
         FREEC BLOCK=R1
GETKP_NOHDRS_TEST&KPT DS 0H
*
         CLI   REFRESH,X'01'
         JNE   GETKPT_NOREFRESH_TEST&KPT
         LGHI  R2,17              MSG 17
         BRASL R6,KP_WTOPC_I
         GETKC KPT=&KPT,DATA=R1,ERROR=GETKP_ERROR5&KPT,REFRESH
         BRAS  R6,SNAPKPT&KPT
         LGHI  R2,18              MSG 18
         BRASL R6,KP_WTOPC_I
         FREEC BLOCK=R1
*
GETKPT_NOREFRESH_TEST&KPT DS 0H
         CLI   TOUT,X'01'
         JNE   GETKP_NO_TOTEST&KPT
         LGHI  R2,19              MSG 19
         BRASL R6,KP_WTOPC_I
         GETKC KPT=&KPT,DATA=R1,ERROR=GETKP_ERROR2&KPT,HOLD
         BRAS  R6,SNAPKPT&KPT
         LGHI  R2,20              MSG 20
         BRASL R6,KP_WTOPC_I
         LGHI  R2,21              MSG 21
         BRASL R6,KP_WTOPC_I
         USING EV0BK,R4
         LA    R4,EVNBKL
         MALOC SIZE=R4
         LGHI   R15,1
         STH   R15,EVNBKC1            COUNT
         EVNTC BLOCK=(R4),TYPE=CNT,TIMEOUT=10
         MVI   EBW000,HOLD&KPT
         MVC   EBW001,EBCM01
         MVC   EBW002(L'EBROUT),EBROUT
         MVC   EBW008(L'EVNBKN),EVNBKN
         LGHI  R14,16
         LA    R15,EBW000
         CREMC QKP2
         EVNWC BLOCK=(R4),TYPE=CNT,ERROR=GETKP_TOERR&KPT
         J     GETKP_TOTEST_OK&KPT
GETKP_TOERR&KPT   DS   0H
         LGHI  R2,22               MSG 22
         BRASL R6,KP_WTOPC_I
GETKP_TOTEST_OK&KPT DS 0H
         FREEC BLOCK=R4
         RELKC KPT=&KPT
         LGHI  R2,23              MSG 23
         BRASL R6,KP_WTOPC_I
         FREEC BLOCK=R1
*
GETKP_NO_TOTEST&KPT DS   0H
         CLI   PROCREQ,X'01'
         JNE   GETKP_NO_PROCTEST&KPT

*   TAG KEYPOINT
         CLI   TAG,X'01'          DO WE TAG?
         JNE   TAGKPT_7_NO&KPT
         MVI   QKP3_LOCATION,X'00'
         MVC   QKP3_TAG_DATA,GETKP_TAG&KPT
         MVC   QKP3_KPT_PARM,KPT
         MVC   QKP3_TARGET_PROC,CPUID
         MVC   QKP3_VERBOSE,VERBOSE
         MVC   QKP3_PROC_ORD,CPUORD
         MVC   QKP3_IMAGE_NO,X'00'
         ENTRC QKP3
         CLI   QKP3_RETCODE,QKP3_RET_OK
         JNE   GETKP_ERROR9&KPT
TAGKPT_7_NO&KPT   DS 0H

         LGHI  R2,24               MSG 24
         BRASL R6,KP_WTOPC_I
         XGR   R2,R2
         ICM   R2,B'0011',CPUORD
         GETKC KPT=&KPT,DATA=R1,HOLD,ERROR=GETKP_ERROR4&KPT,PROC=R2
         CLI   TAG,X'01'          DO WE TAG?
         JNE   TAGKPT_8_NO&KPT
         CLC   4(4,R1),QKP3_TAG_DATA
         JNE   GETKP_ERROR9_UNHOLD&KPT
TAGKPT_8_NO&KPT   DS 0H

         BRAS  R6,SNAPKPT&KPT
         UPDKC KPT=&KPT,DATA=R1,UNHOLD,ERROR=GETKP_ERROR4&KPT,PROC=R2
         FREEC BLOCK=R1
         GETKC KPT=&KPT,DATA=R1,ERROR=GETKP_ERROR4&KPT,PROC=R2
         BRAS  R6,SNAPKPT&KPT
         CLI   TAG,X'01'          DO WE TAG?
         JNE   TAGKPT_9_NO&KPT
         CLC   4(4,R1),QKP3_TAG_DATA
         JE    GETKP_ERROR9&KPT
TAGKPT_9_NO&KPT   DS 0H

         LGHI  R2,25               MSG 25
         BRASL R6,KP_WTOPC_I
         FREEC BLOCK=R1
*
GETKP_NO_PROCTEST&KPT DS 0H
         CLI  KBAREQ,X'00'     TEST KBA ?
         JE   GETKP_NO_KBA&KPT         NO
         LGHI  R2,29               MSG 29
         BRASL R6,KP_WTOPC_I

*   TAG KEYPOINT
         CLI   TAG,X'01'          DO WE TAG?
         JNE   TAGKPT_10_NO&KPT
         MVI   QKP3_LOCATION,QKP3_KBA
         MVC   QKP3_TAG_DATA,GETKP_TAG&KPT
         MVC   QKP3_KPT_PARM,KPT
         MVC   QKP3_TARGET_PROC,X'00'
         MVC   QKP3_VERBOSE,VERBOSE
         MVC   QKP3_PROC_ORD,CPUORD
         MVC   QKP3_IMAGE_NO,X'00'
         ENTRC QKP3
         CLI   QKP3_RETCODE,QKP3_RET_OK
         JNE   GETKP_ERROR9&KPT
TAGKPT_10_NO&KPT  DS 0H

         GETKC KPT=&KPT,DATA=R1,ERROR=GETKP_ERROR6&KPT,KBA
         CLI   TAG,X'01'          DO WE TAG?
         J     TAGKPT_11_NO&KPT
         CLC   4(4,R1),QKP3_TAG_DATA
         JNE   GETKP_ERROR9&KPT
TAGKPT_11_NO&KPT  DS 0H

         BRAS  R6,SNAPKPT&KPT
         LGHI  R2,26               MSG 26
         BRASL R6,KP_WTOPC_I
         FREEC BLOCK=R1
GETKP_NO_KBA&KPT  DS    0H
         CLI   KSAREQ,X'00'  TEST KSA ?
         JE    GETKP_NO_KSA&KPT          NO

*   TAG KEYPOINT
         CLI   TAG,X'01'          DO WE TAG?
         JNE   TAGKPT_12_NO&KPT
         MVI   QKP3_LOCATION,QKP3_KSA
         MVC   QKP3_TAG_DATA,GETKP_TAG&KPT
         MVC   QKP3_KPT_PARM,KPT
         MVC   QKP3_TARGET_PROC,X'00'
         MVC   QKP3_VERBOSE,VERBOSE
         MVC   QKP3_PROC_ORD,CPUORD
         MVC   QKP3_IMAGE_NO,IMAGE
         CLI   QKP3_IMAGE_NO,X'00'
         JNE   GETKP_GOT_IMAGE&KPT
         CINFC R,CMMAIM,F          GET ACTIVE IMAGE NUMBER
         STC   R14,QKP3_IMAGE_NO
GETKP_GOT_IMAGE&KPT DS 0H
         ENTRC QKP3
         CLI   QKP3_RETCODE,QKP3_RET_OK
         JNE   GETKP_ERROR9&KPT
TAGKPT_12_NO&KPT  DS 0H
         LGHI  R2,27               MSG 27
         BRASL R6,KP_WTOPC_I
         XGR   R2,R2
         ICM   R2,B'0001',IMAGE
         GETKC KPT=&KPT,DATA=R1,ERROR=GETKP_ERROR6&KPT,KSA,IMAGE=R2
         CLI   TAG,X'01'          DO WE TAG?
         JNE   TAGKPT_13_NO&KPT
         CLC   4(4,R1),QKP3_TAG_DATA
         JNE   GETKP_ERROR9&KPT
TAGKPT_13_NO&KPT  DS 0H

         BRAS  R6,SNAPKPT&KPT
         LGHI  R2,28               MSG 28
         BRASL R6,KP_WTOPC_I
         FREEC BLOCK=R1
GETKP_NO_KSA&KPT  DS    0H
         CLI   KLGFBAREQ,X'00'  TEST KLGFBA ?
         JE    GETKP_NO_KLGFBA&KPT          NO
         LGHI  R2,30               MSG 30
         BRASL R6,KP_WTOPC_I
GETKP_NO_KLGFBA&KPT  DS    0H
         J     NO_ETEST&KPT         NO
*
**********************************************************************
*    TEST NO MALLOC STORAGE AVAILABE FOR GETKC                       *
**********************************************************************
ETEST_CASE1&KPT    DS  0H
         BRASL R6,KP_EAT_STORE
         GETKC KPT=&KPT,DATA=R1,ERROR=GETKP_TERR1&KPT
GETKP_TERR1_BAD&KPT DS 0H
         LGHI  R2,1              ETEST_MSGE1
         BRASL R6,KP_WTOPC_ETEST
         J     GETKP_TERR1_FREE&KPT
GETKP_TERR1&KPT   DS   0H
         CGHI  R15,IGETKC_MALOC
         JNE   GETKP_TERR1_BAD&KPT
         LGHI  R2,2              ETEST_MSGE2
         BRASL R6,KP_WTOPC_ETEST
GETKP_TERR1_FREE&KPT    DS 0H
         BRASL R6,KP_FREE_STORE
         J     NO_ETEST&KPT
**********************************************************************
*    TEST NO MALLOC STORAGE AVAILABE FOR UPDKC                       *
**********************************************************************
ETEST_CASE2&KPT   DS  0H
         GETKC KPT=&KPT,DATA=R1,HOLD,ERROR=GETKP_TERR2_BAD&KPT
         STG   R1,SAVEREG1
         BRASL R6,KP_EAT_STORE
         LG    R1,SAVEREG1
         UPDKC KPT=&KPT,DATA=R1,ERROR=GETKP_TERR2&KPT
GETKP_TERR2_BAD_RELEASE&KPT DS 0H
         RELKC KPT=&KPT
GETKP_TERR2_BAD&KPT   DS 0H
         LGHI  R2,3            ETEST MSGE3
         BRASL R6,KP_WTOPC_ETEST
         J     GETKP_TERR2_FREE&KPT
GETKP_TERR2&KPT   DS   0H
         CGHI  R15,IUPDKC_MALOC
         JNE   GETKP_TERR2_BAD_RELEASE&KPT
         LGHI  R2,4            ETEST_MSGE4
         BRASL R6,KP_WTOPC_ETEST
         RELKC KPT=&KPT
GETKP_TERR2_FREE&KPT    DS 0H
         BRASL R6,KP_FREE_STORE
         J     NO_ETEST&KPT
**********************************************************************
*    TEST GETKC HOLD, ECB EXITS without RELKC                        *
**********************************************************************
ETEST_CASE3&KPT    DS  0H
         GETKC KPT=&KPT,DATA=R1,HOLD,ERROR=GETKP_TERR3_BAD&KPT
         LGHI  R2,14            ETEST_MSGE14
         BRASL R6,KP_WTOPC_ETEST
         EXITC
GETKP_TERR3_BAD&KPT DS   0H
         LGHI  R2,5            ETEST_MSGE5
         BRASL R6,KP_WTOPC_ETEST
         J     NO_ETEST&KPT
**********************************************************************
*    TEST GETKC HOLD, ECB SERRC EXITS without RELKC                  *
**********************************************************************
ETEST_CASE4&KPT    DS  0H
         GETKC KPT=&KPT,DATA=R1,HOLD,ERROR=GETKP_TERR4_BAD&KPT
         LGHI  R2,15            ETEST_MSGE15
         BRASL R6,KP_WTOPC_ETEST
         SERRC E,F00F00
GETKP_TERR4_BAD&KPT DS 0H
         LGHI  R2,6             ETEST_MSGE6
         BRASL R6,KP_WTOPC_ETEST
         J     NO_ETEST&KPT
**********************************************************************
*    TEST UPDKC UNOLD WHEN NOT HOLDING                               *
**********************************************************************
ETEST_CASE5&KPT    DS  0H
         GETKC KPT=&KPT,DATA=R1,ERROR=GETKP_TERR5_BAD&KPT
         LGHI  R2,16             ETEST_MSGE16
         BRASL R6,KP_WTOPC_ETEST
         UPDKC KPT=&KPT,DATA=R1,UNHOLD,ERROR=GETKP_TERR5&KPT
GETKP_TERR5&KPT DS 0H
         CGHI  R15,IUPDKC_MALOC
         JE   GETKP_TERR5_BAD&KPT
         LGHI  R2,7             ETEST_MSGE7
         BRASL R6,KP_WTOPC_ETEST
         J     NO_ETEST&KPT
GETKP_TERR5_BAD&KPT DS 0H
         LA    R1,8             ETEST_MSGE8
         BRASL R6,KP_WTOPC_ETEST
         J     NO_ETEST&KPT
**********************************************************************
*    TEST UPDKC WITH BAD IMAGE                                       *
**********************************************************************
ETEST_CASE6&KPT    DS  0H
         GETKC KPT=&KPT,DATA=R1,ERROR=GETKP_TERR6_BAD&KPT
         LGHI  R2,17             ETEST_MSGE7
         BRASL R6,KP_WTOPC_ETEST
         LGHI  R2,-1
         UPDKC KPT=&KPT,DATA=R1,ERROR=GETKP_TERR6&KPT,KSA,IMAGE=R2
GETKP_TERR6&KPT DS 0H
         CGHI  R15,IUPDKC_MALOC
         JE    GETKP_TERR6_BAD&KPT
         LGHI  R2,9             ETEST_MSGE9
         BRASL R6,KP_WTOPC_ETEST
         J     NO_ETEST&KPT
GETKP_TERR6_BAD&KPT  DS 0H
         LGHI  R2,10            ETEST_MSGE10&KPT
         BRASL R6,KP_WTOPC_ETEST
         J     NO_ETEST&KPT
**********************************************************************
*    TEST UPDKC WITH BAD HDRS                                        *
**********************************************************************
ETEST_CASE7&KPT    DS  0H
         LGHI  R2,19             ETEST_MSGE19
         BRASL R6,KP_WTOPC_ETEST
         GETKC KPT=&KPT,DATA=R1,HOLD,ERROR=GETKP_TERR7_BAD&KPT,HDRS
         XC    0(16,R1),0(R1)
         UPDKC KPT=&KPT,DATA=R1,UNHOLD,ERROR=GETKP_TERR7&KPT,HDRS
GETKP_TERR7&KPT DS 0H
         CGHI  R15,IUPDKC_MALOC
         JE   GETKP_TERR7_BAD&KPT
         LGHI  R2,11             ETEST_MSGE11
         BRASL R6,KP_WTOPC_ETEST
         J     NO_ETEST&KPT
GETKP_TERR7_BAD&KPT  DS 0H
         LGHI  R2,12             ETEST_MSGE12
         BRASL R6,KP_WTOPC_ETEST
         J     NO_ETEST&KPT
**********************************************************************
*    TEST RELKC KPT NOT HELD                                         *
**********************************************************************
ETEST_CASE8&KPT    DS  0H
         GETKC KPT=&KPT,DATA=R1,ERROR=GETKP_TERR8_BAD&KPT
         LGHI  R2,18             ETEST_MSGE18
         BRASL R6,KP_WTOPC_ETEST
         RELKC KPT=&KPT
GETKP_TERR8_BAD&KPT  DS 0H
         LGHI  R2,13             ETEST_MSGE13
         BRASL R6,KP_WTOPC_ETEST
         J     NO_ETEST&KPT
**********************************************************************
*    TEST INVALID PROCESSOR INPUT                                    *
**********************************************************************
ETEST_CASE9&KPT    DS  0H
         LGHI  R2,20
         BRASL R6,KP_WTOPC_ETEST
         LGHI   R2,254
         GETKC KPT=&KPT,DATA=R1,ERROR=GETKP_TERR9&KPT,PROC=R2
GETKP_TERR9&KPT   DS 0H
         LGHI  R2,21
         BRASL R6,KP_WTOPC_ETEST
         J     NO_ETEST&KPT
**********************************************************************
*    END OF ERROR CASE TESTS                                         *
**********************************************************************
NO_ETEST&KPT DS 0H
         J     GETKP_END&KPT
*
*
GETKP_ERROR1&KPT   DS   0H
         LGHI  R2,1                EMSG 1
         BRASL R6,KP_WTOPC_E
         J     GETKP_END&KPT
GETKP_ERROR2&KPT   DS   0H
         LGHI  R2,2                EMSG 2
         BRASL R6,KP_WTOPC_E
         J     GETKP_END&KPT
GETKP_ERROR3&KPT   DS   0H
         LGHI  R2,3                EMSG 3
         BRASL R6,KP_WTOPC_E
         J     GETKP_END&KPT
GETKP_ERROR4&KPT   DS   0H
         LGHI  R2,4                EMSG 4
         BRASL R6,KP_WTOPC_E
         J     GETKP_END&KPT
GETKP_ERROR5&KPT   DS   0H
         LGHI  R2,5                EMSG 5
         BRASL R6,KP_WTOPC_E
         J     GETKP_END&KPT
GETKP_ERROR6&KPT   DS   0H
         LGHI  R2,6                EMSG 6
         BRASL R6,KP_WTOPC_E
         J     GETKP_END&KPT
GETKP_ERROR7&KPT   DS   0H
         LGHI  R2,7                EMSG 7
         BRASL R6,KP_WTOPC_E
         J     GETKP_END&KPT
GETKP_ERROR8&KPT   DS   0H
         LGHI  R2,8                EMSG 8
         BRASL R6,KP_WTOPC_E
         J     GETKP_END&KPT
GETKP_ERROR9_UNHOLD&KPT DS 0H
         RELKC KPT=&KPT
GETKP_ERROR9&KPT   DS   0H
         LGHI  R2,9                EMSG 9
         BRASL R6,KP_WTOPC_E
         J     GETKP_END&KPT
         LTORG
GETKP_END&KPT DS   0H
         PRINT NOGEN
         MEND
         EJECT
*        DRV51
         CLHEQ
         CZ3CP
         IEQCE2
         IEQCE3
         EV0BK
* Input parms
         INPARMS
SAVEREG1 EQU   EBX024
***********************************************************************
* this function tests keypoint A.                                     *
***********************************************************************
         PRLGC ENAME=getkpta_macro,BASE=R7
         KPTTEST KEYPOINT=A,PARMS=EBX008
         EPLGC RC=NONE
         EJECT
***********************************************************************
* this function tests keypoint B.                                     *
***********************************************************************
         PRLGC ENAME=getkptb_macro,BASE=R7
         KPTTEST KEYPOINT=B,PARMS=EBX008
         EPLGC RC=NONE
         EJECT
***********************************************************************
* this function tests keypoint C.                                     *
***********************************************************************
         PRLGC ENAME=getkptc_macro,BASE=R7
         KPTTEST KEYPOINT=C,PARMS=EBX008
         EPLGC RC=NONE
         EJECT
***********************************************************************
* this function tests keypoint D.                                     *
***********************************************************************
         PRLGC ENAME=getkptd_macro,BASE=R7
         KPTTEST KEYPOINT=D,PARMS=EBX008
         EPLGC RC=NONE
         EJECT
***********************************************************************
* this function tests keypoint E.                                     *
***********************************************************************
         PRLGC ENAME=getkpte_macro,BASE=R7
         KPTTEST KEYPOINT=E,PARMS=EBX008
         EPLGC RC=NONE
         EJECT
***********************************************************************
* this function tests keypoint I.                                     *
***********************************************************************
         PRLGC ENAME=getkpti_macro,BASE=R7
         KPTTEST KEYPOINT=I,PARMS=EBX008
         EPLGC RC=NONE
         EJECT
***********************************************************************
* this function tests keypoint M.                                     *
***********************************************************************
         PRLGC ENAME=getkptm_macro,BASE=R7
         KPTTEST KEYPOINT=M,PARMS=EBX008
         EPLGC RC=NONE
         EJECT
***********************************************************************
* this function tests keypoint V.                                     *
***********************************************************************
         PRLGC ENAME=getkptv_macro,BASE=R7
         KPTTEST KEYPOINT=V,PARMS=EBX008
         EPLGC RC=NONE
         EJECT
***********************************************************************
* this function tests keypoint 0.                                     *
***********************************************************************
         PRLGC ENAME=getkpt0_macro,BASE=R7
         KPTTEST KEYPOINT=0,PARMS=EBX008
         EPLGC RC=NONE
         EJECT
***********************************************************************
* this function tests keypoint 1.                                     *
***********************************************************************
         PRLGC ENAME=getkpt1_macro,BASE=R7
         KPTTEST KEYPOINT=1,PARMS=EBX008
         EPLGC RC=NONE
         EJECT
***********************************************************************
* this function tests keypoint 2.                                     *
***********************************************************************
         PRLGC ENAME=getkpt2_macro,BASE=R7
         KPTTEST KEYPOINT=2,PARMS=EBX008
         EPLGC RC=NONE
         EJECT
***********************************************************************
* this function tests keypoint 3.                                     *
***********************************************************************
         PRLGC ENAME=getkpt3_macro,BASE=R7
         KPTTEST KEYPOINT=3,PARMS=EBX008
         EPLGC RC=NONE
         EJECT
***********************************************************************
* this function tests keypoint 4.                                     *
***********************************************************************
         PRLGC ENAME=getkpt4_macro,BASE=R7
         KPTTEST KEYPOINT=4,PARMS=EBX008
         EPLGC RC=NONE
         EJECT
***********************************************************************
* this function tests keypoint 5.                                     *
***********************************************************************
         PRLGC ENAME=getkpt5_macro,BASE=R7
         KPTTEST KEYPOINT=5,PARMS=EBX008
         EPLGC RC=NONE
         EJECT
***********************************************************************
* this function tests keypoint 6.                                     *
***********************************************************************
         PRLGC ENAME=getkpt6_macro,BASE=R7
         KPTTEST KEYPOINT=6,PARMS=EBX008
         EPLGC RC=NONE
         EJECT
***********************************************************************
* this function tests keypoint 9.                                     *
***********************************************************************
         PRLGC ENAME=getkpt9_macro,BASE=R7
         KPTTEST KEYPOINT=9,PARMS=EBX008
         EPLGC RC=NONE
         EJECT
***********************************************************************
* this function tests keypoint Z.                                     *
***********************************************************************
         PRLGC ENAME=getkptz_macro,BASE=R7
         KPTTEST KEYPOINT=Z,PARMS=EBX008
         EPLGC RC=NONE
         EJECT
***********************************************************************
* this function converts cpuid to cpu ordinal                         *
***********************************************************************
         PRLGC ENAME=cvt_cpuid,BASE=R7
*                              R2 POINTS to CPUID
*                              R3 POINTS TO LOCATION TO RETURN ORD
         XGR   R15,R15            CLEAR FOR CONVERSION
         CCIDC CPUID=0(,R2)       CONVERT CPUID TO ORD
         LTGR  R0,R0              GOOD RETURN?
         JE    GOOD_CVT           YES..
         WTOPC PREFIX=QKP0,TIME=YES,NUM=01,LET=I,                      X
               TEXT='ERROR CONVERTING CPUID. USE ERR-9 TO TEST INVALID X
               PROCESSOR'
         LGHI  R15,254            SET INVALID CPU ORDINAL
GOOD_CVT DS    0H
         STCM  R15,B'0011',0(R3)  STORE ORD IN CPU ORD PARM
         EPLGC RC=NONE
*
             LTORG

***********************************************************************
* STATUS WTOPC                                                        *
***********************************************************************
KP_WTOPC_I DS    0H
         BRAS  R3,*+4
         USING KP_WTOPC_I_START,R3
KP_WTOPC_I_START EQU   *
         CLI   VERBOSE,X'00'
         JE    KP_WTOPC_I_NOMSG
         BCTGR R2,0
         MGHI  R2,MSG_T_LEN
         LA    R2,KP_MSG_TAB(R2)
         PRINT GEN
         WTOPC PREFIX=QKP0,TIME=YES,NUM=01,LET=I,                      X
               TEXTA=KP_MSG,SUB=(CHARA,KPT,CHARA,(R2))
         PRINT NOGEN
KP_WTOPC_I_NOMSG DS   0H
         BR    R6

KP_MSG    DC    AL1(L'KP_MSG_T)
KP_MSG_T  DC    C'BSO test kpt: .. ................'

KP_MSG_TAB EQU *
KP_MSG1   DC   C'retrieving.     '
MSG_T_LEN  EQU  *-KP_MSG_TAB
KP_MSG2   DC   C'retrieved.      '
KP_MSG3   DC   C'retrieving HOLD.'
KP_MSG4   DC   C'retrieved HOLD. '
KP_MSG5   DC   C'UPDATE          '
KP_MSG6   DC   C'UPDATED         '
KP_MSG7   DC   C'RELEASED        '
KP_MSG8   DC   C'retrieving HOLD.'
KP_MSG9   DC   C'retrieved HOLD. '
KP_MSG10  DC   C'RELEASE         '
KP_MSG11  DC   C'UPDATE UNHOLD   '
KP_MSG12  DC   C'UPDATED         '
KP_MSG13  DC   C'test HDRS.      '
KP_MSG14  DC   C'tested HDRS     '
KP_MSG15  DC   C'test IMAGE.     '
KP_MSG16  DC   C'tested IMAGE    '
KP_MSG17  DC   C'test REFRESH.   '
KP_MSG18  DC   C'tested REFRESH  '
KP_MSG19  DC   C'test HOLD.      '
KP_MSG20  DC   C'holding         '
KP_MSG21  DC   C'Create T/O ECB  '
KP_MSG22  DC   C'T/O malfunction '
KP_MSG23  DC   C'released HOLD   '
KP_MSG24  DC   C'test PROC       '
KP_MSG25  DC   C'tested PROC     '
KP_MSG26  DC   C'tested KBA      '
KP_MSG27  DC   C'test KSA.       '
KP_MSG28  DC   C'tested KSA      '
KP_MSG29  DC   C'test KBA.       '
KP_MSG30  DC   C'KLGFBA N/A      '
         LTORG
         DROP  R3
***********************************************************************
* ERROR MESSAGE WTOPC                                                 *
***********************************************************************
KP_WTOPC_E DS    0H
         USING KP_WTOPC_E_START,R3
         BRAS  R3,*+4
KP_WTOPC_E_START EQU   *
*        CLI   VERBOSE,X'00'
*        JE    KP_WTOPC_E_NOMSG
         BCTGR R2,0
         MGHI  R2,KP_EMSG_T_LEN
         LA    R2,KP_EMSG_TAB(R2)
         WTOPC PREFIX=QKP0,TIME=YES,NUM=01,LET=E,                      X
               TEXTA=KP_MSG_E,SUB=(CHARA,KPT,CHARA,(R2))
KP_WTOPC_E_NOMSG DS    0H
         BR    R6

KP_MSG_E  DC    AL1(L'KP_MSG_ET)
KP_MSG_ET DC    C'BSO ERROR kpt: .. ...............'

KP_EMSG_TAB EQU *
KP_MSG_E1 DC   C'GETKC          '
KP_EMSG_T_LEN  EQU  *-KP_EMSG_TAB
KP_MSG_E2 DC   C'GETKC HOLD     '
KP_MSG_E3 DC   C'GETKC T/O      '
KP_MSG_E4 DC   C'GETKC PROC     '
KP_MSG_E5 DC   C'GETKC REFRESH  '
KP_MSG_E6 DC   C'GETKC KSA      '
KP_MSG_E7 DC   C'GETKC IMAGE    '
KP_MSG_E8 DC   C'UPDKC          '
KP_MSG_E9 DC   C'TAG FAILURE    '
         LTORG
         DROP  R3
***********************************************************************
* ERROR TEST CASE WTOPC                                               *
***********************************************************************
KP_WTOPC_ETEST DS    0H
         USING KP_WTOPC_ETEST_START,R3
         BRAS  R3,*+4
KP_WTOPC_ETEST_START EQU   *
         CLI   VERBOSE,X'00'
         JE    KPA_WTOPC_ETEST_NOMSG
         BCTGR R2,0
         MGHI  R2,MSG_ETEST_T_LEN
         LA    R2,ETEST_MSG_TAB(R2)
         WTOPC PREFIX=QKP0,TIME=YES,NUM=01,LET=E,                      X
               TEXTA=KP_ETEST_MSG,SUB=(CHARA,KPT,CHARA,(R2))
KPA_WTOPC_ETEST_NOMSG DS    0H
         BR    R6

KP_ETEST_MSG DC AL1(L'KP_ETEST_MSG_T)
KP_ETEST_MSG_T DC C'BSO ERROR TEST kpt: .. ............................X
               ....... '
*
**********************************************************************
* KPT ERROR TEST MESSAGES                                            *
**********************************************************************
ETEST_MSG_TAB EQU  *
ETEST_MSGE1    DC C'Failed no-storage test for GETKC    '
MSG_ETEST_T_LEN     EQU *-ETEST_MSG_TAB
ETEST_MSGE2    DC C'Passed no-storage test for GETKC    '
ETEST_MSGE3    DC C'Failed no-storage test for UPDKC    '
ETEST_MSGE4    DC C'Passed no-storage test for UPDKC    '
ETEST_MSGE5    DC C'Failed error case 3                 '
ETEST_MSGE6    DC C'Failed error case 4                 '
ETEST_MSGE7    DC C'Passed UNHOLD error test for UPDKC  '
ETEST_MSGE8    DC C'Failed UNHOLD error test for UPDKC  '
ETEST_MSGE9_   DC C'Passed bad IMAGE error test - UPDKC '
ETEST_MSGE10   DC C'Failed bad IMAGE error test - UPDKC '
ETEST_MSGE11   DC C'Passed bad HDRS error test - UPDKC  '
ETEST_MSGE12   DC C'Failed bad HDRS error test - UPDKC  '
ETEST_MSGE13   DC C'Failed RELKC error test.            '
ETEST_MSGE14   DC C'Exit while holding. CTL-8 Expected  '
ETEST_MSGE15   DC C'DUMP Exit holding. F00F00 Expected  '
ETEST_MSGE16   DC C'UNHOLD-not holding. CTL-24 Expected '
ETEST_MSGE17   DC C'INVALID IMAGE. OPR-0640F2 Expected  '
ETEST_MSGE18   DC C'RELKC-not holding. CTL-24 Expected  '
ETEST_MSGE19   DC C'INVALID HDRS. OPR-0640F2 Expected   '
ETEST_MSGE20   DC C'INVALID PROC. OPR-0640FD Expected   '
ETEST_MSGE21   DC C'Failed INVALID PROC test.           '
         LTORG
         DROP  R3
*
KP_FREE_STORE   DS  0H
         USING KP_FREE_STORE_START,R3
         BRAS  R3,*+4
KP_FREE_STORE_START EQU   *
         XGR   R2,R2
         LEVTA LEVEL=1,NOTUSED=FREE_RETURN
         L     R2,CE1CR1
         LG    R1,0(,R2)              LOAD COUNT
         LTGR  R1,R1                  GOT SOME TO FREE?
         JZ    FREE_RETURN            NO
FREE_LOOP DS   0H
         AGHI  R2,8                   POINT TO BLOCK
         LG    R15,0(,R2)             GET ADDR
         FREEC BLOCK=R15             FREE BLOCK
         BCTG  R1,FREE_LOOP           GET NEXT
FREE_RETURN    DS 0H
         BR    R6                     RETURN
         DROP  R3
*
KP_EAT_STORE   DS  0H
         USING KP_EAT_STORE_START,R3
         BRAS  R3,*+4
KP_EAT_STORE_START EQU   *
         GETCC D1,L2
         XC    0(8,R14),0(R14)       CLEAR COUNT
         LLGF  R0,XSTORE_MSIZE_1
XSTORE_LOOP_1  DS    0H
         LGR   R2,R0
         MALOC SIZE=R2,HEAP=64BIT
         LTGR  R2,R2
         JZ    XSTORE_NEXT
         XGR   R14,R14
         L     R14,CE1CR1            GET BASE
         LG    R15,0(,R14)           GET COUNT
         LA    R15,1(,R15)           BUMP COUNT
         STG   R15,0(,R14)           SAVE IT
         MGHI  R15,8
         STG   R2,0(R15,R14)         SAVE MALOC ADDR
         J     XSTORE_LOOP_1
XSTORE_NEXT    DS    0H
         SRLG  R0,R0,1
         CGF   R0,XSTORE_MSIZE_2
         JL    XSTORE_DONE_64
         J     XSTORE_LOOP_1
XSTORE_DONE_64 DS    0H
         LLGF  R0,XSTORE_MSIZE_1
XSTORE_LOOP_2  DS    0H
         LGR   R2,R0
         MALOC SIZE=R2,HEAP=31BIT
         LTGR  R2,R2
         JZ    XSTORE_NEXT_31
         L     R14,CE1CR1            GET BASE
         LG    R15,0(,R14)           GET COUNT
         LA    R15,1(,R15)           BUMP COUNT
         STG   R15,0(,R14)           SAVE IT
         MGHI  R15,8
         STG   R2,0(R15,R14)         SAVE MALOC ADDR
         J     XSTORE_LOOP_2
XSTORE_NEXT_31 DS    0H
         SRLG  R0,R0,1
         CGF   R0,XSTORE_MSIZE_2
         JL    XSTORE_DONE_31
         J     XSTORE_LOOP_2
XSTORE_DONE_31 DS    0H
         BR    R6
XSTORE_MSIZE_1 DC    A(1048568)
XSTORE_MSIZE_2 DC    A(4095)
         DROP  R3
         LTORG
         EJECT
         FINIS
         END
