         PRINT NOGEN
         BEGIN NAME=QKP2
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
*   MODULE NAME ....... QKP2                                          *
*   RELATED MODULES ... QKP0                                          *
*   DOCUMENT NAME ..... z/TPF KPTS Driver User's Guide                *
*   DESCRIPTION ....... KEYPOINT test driver                          *
*   LEVEL ............. Version 1 Modification 3                      *
*                                                                     *
*   FUNCTION: This segment attempts to hold a keypoint that should    *
*             already be held by the parent ECB. The purpose is to    *
*             test the timeout option. If sucessful, the HOLD request *
*             will timeout and display a successful status before     *
*             posting an event back to the parent.                    *
*             This segment is called via CREMC. The requested keypoint*
*             is designated by the parm passed in EBW000              *
*                                                                     *
*   MODULE ATTRIBUTES:                                                *
*     Type ......... 'E' (ECB controlled)                             *
*     Processor .... Shared, subsystem unique                         *
*     Allocation ... File resident                                    *
*     Environment .. Driver                                           *
*                                                                     *
*                                                                     *
***********************************************************************
         EV0BK
         MVC   EBCM01,EBW001            SET VERBOSE
         MVC   EBROUT,EBW002            SET EBROUT
*
         USING EV0BK,R4
         LA    R4,EVNBKL
         MALOC SIZE=R4
         MVC   EVNBKN,EBW008
         MVI   EBX002,X'40'        blank for Keypt value for display
*
         XR    R1,R1
         IC    R1,EBW000
         SLL   R1,2                Multiply by 4 for Table item lenth
         L     R1,KPTABLE(R1)
         B     KPTABLE(R1)
KPTABLE  DS    0H
         DC    AL4(KPTERR-KPTABLE)
         DC    AL4(KPTA-KPTABLE)
         DC    AL4(KPTB-KPTABLE)
         DC    AL4(KPTC-KPTABLE)
         DC    AL4(KPTD-KPTABLE)
         DC    AL4(KPTE-KPTABLE)
         DC    AL4(KPTI-KPTABLE)
         DC    AL4(KPTM-KPTABLE)
         DC    AL4(KPTV-KPTABLE)
         DC    AL4(KPT0-KPTABLE)
         DC    AL4(KPT1-KPTABLE)
         DC    AL4(KPT2-KPTABLE)
         DC    AL4(KPT3-KPTABLE)
         DC    AL4(KPT4-KPTABLE)
         DC    AL4(KPT5-KPTABLE)
         DC    AL4(KPT6-KPTABLE)
         DC    AL4(KPT9-KPTABLE)
KPTERR   DS    0H
         WTOPC TEXT='getkc: Invalid parm to QKP2.'
         B     EXIT
POSTIT   DS    0H
         POSTC BLOCK=(R4),TYPE=CNT,NFOUND=POSTERR
         BR    R7
POSTERR  DS    0H
         WTOPC TEXT='getkc: Post failer on timeout test.'
         BR    R7
EXIT     DS    0H
         EXITC
**********************************************************************
* STATUS MSGS                                                        *
*                                                                    *
*                                                                    *
**********************************************************************
MSG1     DS    0H
         CLI   EBCM01,X'00'
         BER   R7
         WTOPC TEXT='BSO kpt .. retrieving for HOLD TIMEOUT',          X
               SUB=(CHARA,EBX001)
         BR    R7
MSG2     DS    0H
         CLI   EBCM01,X'00'
         BER   R7
         WTOPC TEXT='getkc: BSO drvr kpt .. Error- no TIMEOUT.',       X
               SUB=(CHARA,EBX001)
         BR    R7
MSG3     DS    0H
         CLI   EBCM01,X'00'
         BER   R7
         WTOPC TEXT='getkc: BSO drvr retrieving kpt .. TIMEOUT-OK',    X
               SUB=(CHARA,EBX001)
         BR    R7
**********************************************************************
* INDIVIDUAL KEYPOINT ROUTINES                                       *
*                                                                    *
*                                                                    *
**********************************************************************
KPTA     DS    0H
         MVI   EBX001,C'A'
         JAS   R7,MSG1
         GETKC KPT=A,DATA=R2,ERROR=GETKPA_ERROR,HOLD,TIMEOUT=3
GETKPA_BAD     DS 0H
         JAS   R7,MSG2
         J     GETKPA_OUT
GETKPA_ERROR   DS   0H
         CHI   R15,IGETKC_TIME
         JNE   GETKPA_BAD
         JAS   R7,MSG3
GETKPA_OUT DS 0H
         JAS   R7,POSTIT
         WAITC GETKPA_ERROR_EXIT
         RELKC KPT=A
GETKPA_ERROR_EXIT DS 0H
         J     EXIT
         LTORG
*
KPTB     DS    0H
         MVI   EBX001,C'B'
         JAS   R7,MSG1
         GETKC KPT=B,DATA=R2,ERROR=GETKPB_ERROR,HOLD,TIMEOUT=3
GETKPB_BAD     DS 0H
         JAS   R7,MSG2
         J     GETKPB_OUT
GETKPB_ERROR   DS   0H
         CHI   R15,IGETKC_TIME
         JNE   GETKPB_BAD
         JAS   R7,MSG3
GETKPB_OUT DS 0H
         JAS   R7,POSTIT
         WAITC GETKPB_ERROR_EXIT
         RELKC KPT=B
GETKPB_ERROR_EXIT DS 0H
         J     EXIT
         LTORG
*
KPTC     DS    0H
         MVI   EBX001,C'C'
         JAS   R7,MSG1
         GETKC KPT=C,DATA=R2,ERROR=GETKPC_ERROR,HOLD,TIMEOUT=3
GETKPC_BAD     DS 0H
         JAS   R7,MSG2
         J     GETKPC_OUT
GETKPC_ERROR   DS   0H
         CHI   R15,IGETKC_TIME
         JNE   GETKPC_BAD
         JAS   R7,MSG3
GETKPC_OUT DS 0H
         JAS   R7,POSTIT
         WAITC GETKPC_ERROR_EXIT
         RELKC KPT=C
GETKPC_ERROR_EXIT DS 0H
         J     EXIT
*
         LTORG
KPTD     DS    0H
         MVI   EBX001,C'D'
         JAS   R7,MSG1
         GETKC KPT=D,DATA=R2,ERROR=GETKPD_ERROR,HOLD,TIMEOUT=3
GETKPD_BAD     DS 0H
         JAS   R7,MSG2
         J     GETKPD_OUT
GETKPD_ERROR   DS   0H
         CHI   R15,IGETKC_TIME
         JNE   GETKPD_BAD
         JAS   R7,MSG3
GETKPD_OUT DS 0H
         JAS   R7,POSTIT
         WAITC GETKPD_ERROR_EXIT
         RELKC KPT=D
GETKPD_ERROR_EXIT DS 0H
         J     EXIT
         LTORG
KPTE     DS    0H
         MVI   EBX001,C'E'
         JAS   R7,MSG1
         GETKC KPT=E,DATA=R2,ERROR=GETKPE_ERROR,HOLD,TIMEOUT=3
GETKPE_BAD     DS 0H
         JAS   R7,MSG2
         J     GETKPE_OUT
GETKPE_ERROR   DS   0H
         CHI   R15,IGETKC_TIME
         JNE   GETKPE_BAD
         JAS   R7,MSG3
GETKPE_OUT DS 0H
         JAS   R7,POSTIT
         WAITC GETKPE_ERROR_EXIT
         RELKC KPT=E
GETKPE_ERROR_EXIT DS 0H
         J     EXIT
         LTORG
KPTI     DS    0H
         MVI   EBX001,C'I'
         JAS   R7,MSG1
         GETKC KPT=I,DATA=R2,ERROR=GETKPI_ERROR,HOLD,TIMEOUT=3
GETKPI_BAD     DS 0H
         JAS   R7,MSG2
         J     GETKPI_OUT
GETKPI_ERROR   DS   0H
         CHI   R15,IGETKC_TIME
         JNE   GETKPI_BAD
         JAS   R7,MSG3
GETKPI_OUT DS 0H
         JAS   R7,POSTIT
         WAITC GETKPI_ERROR_EXIT
         RELKC KPT=I
GETKPI_ERROR_EXIT DS 0H
         J     EXIT
         LTORG
KPTM     DS    0H
         MVI   EBX001,C'M'
         JAS   R7,MSG1
         GETKC KPT=M,DATA=R2,ERROR=GETKPM_ERROR,HOLD,TIMEOUT=3
GETKPM_BAD     DS 0H
         JAS   R7,MSG2
         J     GETKPM_OUT
GETKPM_ERROR   DS   0H
         CHI   R15,IGETKC_TIME
         JNE   GETKPM_BAD
         JAS   R7,MSG3
GETKPM_OUT DS 0H
         JAS   R7,POSTIT
         WAITC GETKPM_ERROR_EXIT
         RELKC KPT=M
GETKPM_ERROR_EXIT DS 0H
         J     EXIT
         LTORG
KPTV     DS    0H
         MVI   EBX001,C'V'
         JAS   R7,MSG1
         GETKC KPT=V,DATA=R2,ERROR=GETKPV_ERROR,HOLD,TIMEOUT=3
GETKPV_BAD     DS 0H
         JAS   R7,MSG2
         J     GETKPV_OUT
GETKPV_ERROR   DS   0H
         CHI   R15,IGETKC_TIME
         JNE   GETKPV_BAD
         JAS   R7,MSG3
GETKPV_OUT DS 0H
         JAS   R7,POSTIT
         WAITC GETKPV_ERROR_EXIT
         RELKC KPT=V
GETKPV_ERROR_EXIT DS 0H
         J     EXIT
         LTORG
KPT0     DS    0H
         MVI   EBX001,C'0'
         JAS   R7,MSG1
         GETKC KPT=0,DATA=R2,ERROR=GETKP0_ERROR,HOLD,TIMEOUT=3
GETKP0_BAD     DS 0H
         JAS   R7,MSG2
         J     GETKP0_OUT
GETKP0_ERROR   DS   0H
         CHI   R15,IGETKC_TIME
         JNE   GETKP0_BAD
         JAS   R7,MSG3
GETKP0_OUT DS 0H
         JAS   R7,POSTIT
         WAITC GETKP0_ERROR_EXIT
         RELKC KPT=0
GETKP0_ERROR_EXIT DS 0H
         J     EXIT
         LTORG
KPT1     DS    0H
         MVI   EBX001,C'1'
         JAS   R7,MSG1
         GETKC KPT=1,DATA=R2,ERROR=GETKP1_ERROR,HOLD,TIMEOUT=3
GETKP1_BAD     DS 0H
         JAS   R7,MSG2
         J     GETKP1_OUT
GETKP1_ERROR   DS   0H
         CHI   R15,IGETKC_TIME
         JNE   GETKP1_BAD
         JAS   R7,MSG3
GETKP1_OUT DS 0H
         JAS   R7,POSTIT
         WAITC GETKP1_ERROR_EXIT
         RELKC KPT=1
GETKP1_ERROR_EXIT DS 0H
         J     EXIT
         LTORG
KPT2     DS    0H
         MVI   EBX001,C'2'
         JAS   R7,MSG1
         GETKC KPT=2,DATA=R2,ERROR=GETKP2_ERROR,HOLD,TIMEOUT=3
GETKP2_BAD     DS 0H
         JAS   R7,MSG2
         J     GETKP2_OUT
GETKP2_ERROR   DS   0H
         CHI   R15,IGETKC_TIME
         JNE   GETKP2_BAD
         JAS   R7,MSG3
GETKP2_OUT DS 0H
         JAS   R7,POSTIT
         WAITC GETKP2_ERROR_EXIT
         RELKC KPT=2
GETKP2_ERROR_EXIT DS 0H
         J     EXIT
         LTORG
KPT3     DS    0H
         MVI   EBX001,C'3'
         JAS   R7,MSG1
         GETKC KPT=3,DATA=R2,ERROR=GETKP3_ERROR,HOLD,TIMEOUT=3
GETKP3_BAD     DS 0H
         JAS   R7,MSG2
         J     GETKP3_OUT
GETKP3_ERROR   DS   0H
         CHI   R15,IGETKC_TIME
         JNE   GETKP3_BAD
         JAS   R7,MSG3
GETKP3_OUT DS 0H
         JAS   R7,POSTIT
         WAITC GETKP3_ERROR_EXIT
         RELKC KPT=3
GETKP3_ERROR_EXIT DS 0H
         J     EXIT
         LTORG
KPT4     DS    0H
         MVI   EBX001,C'4'
         JAS   R7,MSG1
         GETKC KPT=4,DATA=R2,ERROR=GETKP4_ERROR,HOLD,TIMEOUT=3
GETKP4_BAD     DS 0H
         JAS   R7,MSG2
         J     GETKP4_OUT
GETKP4_ERROR   DS   0H
         CHI   R15,IGETKC_TIME
         JNE   GETKP4_BAD
         JAS   R7,MSG3
GETKP4_OUT DS 0H
         JAS   R7,POSTIT
         WAITC GETKP4_ERROR_EXIT
         RELKC KPT=4
GETKP4_ERROR_EXIT DS 0H
         J     EXIT
         LTORG
KPT5     DS    0H
         MVI   EBX001,C'5'
         JAS   R7,MSG1
         GETKC KPT=5,DATA=R2,ERROR=GETKP5_ERROR,HOLD,TIMEOUT=3
GETKP5_BAD     DS 0H
         JAS   R7,MSG2
         J     GETKP5_OUT
GETKP5_ERROR   DS   0H
         CHI   R15,IGETKC_TIME
         JNE   GETKP5_BAD
         JAS   R7,MSG3
GETKP5_OUT DS 0H
         JAS   R7,POSTIT
         WAITC GETKP5_ERROR_EXIT
         RELKC KPT=5
GETKP5_ERROR_EXIT DS 0H
         J     EXIT
         LTORG
KPT6     DS    0H
         MVI   EBX001,C'6'
         JAS   R7,MSG1
         GETKC KPT=6,DATA=R2,ERROR=GETKP6_ERROR,HOLD,TIMEOUT=3
GETKP6_BAD     DS 0H
         JAS   R7,MSG2
         J     GETKP6_OUT
GETKP6_ERROR   DS   0H
         CHI   R15,IGETKC_TIME
         JNE   GETKP6_BAD
         JAS   R7,MSG3
GETKP6_OUT DS 0H
         JAS   R7,POSTIT
         WAITC GETKP6_ERROR_EXIT
         RELKC KPT=6
GETKP6_ERROR_EXIT DS 0H
         J     EXIT
         LTORG
KPT9     DS    0H
         MVI   EBX001,C'9'
         JAS   R7,MSG1
         GETKC KPT=9,DATA=R2,ERROR=GETKP9_ERROR,HOLD,TIMEOUT=3
GETKP9_BAD     DS 0H
         JAS   R7,MSG2
         J     GETKP9_OUT
GETKP9_ERROR   DS   0H
         CHI   R15,IGETKC_TIME
         JNE   GETKP9_BAD
         JAS   R7,MSG3
GETKP9_OUT DS 0H
         JAS   R7,POSTIT
         WAITC GETKP9_ERROR_EXIT
         RELKC KPT=9
GETKP9_ERROR_EXIT DS 0H
         J     EXIT
         LTORG
         FINIS
         END
